git-rebase.shon commit Merge git://repo.or.cz/git-gui (731ab1f)
   1#!/bin/sh
   2#
   3# Copyright (c) 2005 Junio C Hamano.
   4#
   5
   6USAGE='[--interactive | -i] [-v] [--onto <newbase>] <upstream> [<branch>]'
   7LONG_USAGE='git-rebase replaces <branch> with a new branch of the
   8same name.  When the --onto option is provided the new branch starts
   9out with a HEAD equal to <newbase>, otherwise it is equal to <upstream>
  10It then attempts to create a new commit for each commit from the original
  11<branch> that does not exist in the <upstream> branch.
  12
  13It is possible that a merge failure will prevent this process from being
  14completely automatic.  You will have to resolve any such merge failure
  15and run git rebase --continue.  Another option is to bypass the commit
  16that caused the merge failure with git rebase --skip.  To restore the
  17original <branch> and remove the .git/rebase-apply working files, use the
  18command git rebase --abort instead.
  19
  20Note that if <branch> is not specified on the command line, the
  21currently checked out branch is used.
  22
  23Example:       git-rebase master~1 topic
  24
  25        A---B---C topic                   A'\''--B'\''--C'\'' topic
  26       /                   -->           /
  27  D---E---F---G master          D---E---F---G master
  28'
  29
  30SUBDIRECTORY_OK=Yes
  31OPTIONS_SPEC=
  32. git-sh-setup
  33set_reflog_action rebase
  34require_work_tree
  35cd_to_toplevel
  36
  37RESOLVEMSG="
  38When you have resolved this problem run \"git rebase --continue\".
  39If you would prefer to skip this patch, instead run \"git rebase --skip\".
  40To restore the original branch and stop rebasing run \"git rebase --abort\".
  41"
  42unset newbase
  43strategy=recursive
  44do_merge=
  45dotest="$GIT_DIR"/rebase-merge
  46prec=4
  47verbose=
  48git_am_opt=
  49
  50continue_merge () {
  51        test -n "$prev_head" || die "prev_head must be defined"
  52        test -d "$dotest" || die "$dotest directory does not exist"
  53
  54        unmerged=$(git ls-files -u)
  55        if test -n "$unmerged"
  56        then
  57                echo "You still have unmerged paths in your index"
  58                echo "did you forget to use git add?"
  59                die "$RESOLVEMSG"
  60        fi
  61
  62        cmt=`cat "$dotest/current"`
  63        if ! git diff-index --quiet --ignore-submodules HEAD --
  64        then
  65                if ! git commit --no-verify -C "$cmt"
  66                then
  67                        echo "Commit failed, please do not call \"git commit\""
  68                        echo "directly, but instead do one of the following: "
  69                        die "$RESOLVEMSG"
  70                fi
  71                printf "Committed: %0${prec}d " $msgnum
  72        else
  73                printf "Already applied: %0${prec}d " $msgnum
  74        fi
  75        git rev-list --pretty=oneline -1 "$cmt" | sed -e 's/^[^ ]* //'
  76
  77        prev_head=`git rev-parse HEAD^0`
  78        # save the resulting commit so we can read-tree on it later
  79        echo "$prev_head" > "$dotest/prev_head"
  80
  81        # onto the next patch:
  82        msgnum=$(($msgnum + 1))
  83        echo "$msgnum" >"$dotest/msgnum"
  84}
  85
  86call_merge () {
  87        cmt="$(cat "$dotest/cmt.$1")"
  88        echo "$cmt" > "$dotest/current"
  89        hd=$(git rev-parse --verify HEAD)
  90        cmt_name=$(git symbolic-ref HEAD 2> /dev/null || echo HEAD)
  91        msgnum=$(cat "$dotest/msgnum")
  92        end=$(cat "$dotest/end")
  93        eval GITHEAD_$cmt='"${cmt_name##refs/heads/}~$(($end - $msgnum))"'
  94        eval GITHEAD_$hd='$(cat "$dotest/onto_name")'
  95        export GITHEAD_$cmt GITHEAD_$hd
  96        git-merge-$strategy "$cmt^" -- "$hd" "$cmt"
  97        rv=$?
  98        case "$rv" in
  99        0)
 100                unset GITHEAD_$cmt GITHEAD_$hd
 101                return
 102                ;;
 103        1)
 104                git rerere
 105                die "$RESOLVEMSG"
 106                ;;
 107        2)
 108                echo "Strategy: $rv $strategy failed, try another" 1>&2
 109                die "$RESOLVEMSG"
 110                ;;
 111        *)
 112                die "Unknown exit code ($rv) from command:" \
 113                        "git-merge-$strategy $cmt^ -- HEAD $cmt"
 114                ;;
 115        esac
 116}
 117
 118move_to_original_branch () {
 119        test -z "$head_name" &&
 120                head_name="$(cat "$dotest"/head-name)" &&
 121                onto="$(cat "$dotest"/onto)" &&
 122                orig_head="$(cat "$dotest"/orig-head)"
 123        case "$head_name" in
 124        refs/*)
 125                message="rebase finished: $head_name onto $onto"
 126                git update-ref -m "$message" \
 127                        $head_name $(git rev-parse HEAD) $orig_head &&
 128                git symbolic-ref HEAD $head_name ||
 129                die "Could not move back to $head_name"
 130                ;;
 131        esac
 132}
 133
 134finish_rb_merge () {
 135        move_to_original_branch
 136        rm -r "$dotest"
 137        echo "All done."
 138}
 139
 140is_interactive () {
 141        test -f "$dotest"/interactive ||
 142        while :; do case $#,"$1" in 0,|*,-i|*,--interactive) break ;; esac
 143                shift
 144        done && test -n "$1"
 145}
 146
 147is_interactive "$@" && exec git-rebase--interactive "$@"
 148
 149while test $# != 0
 150do
 151        case "$1" in
 152        --continue)
 153                test -d "$dotest" -o -d "$GIT_DIR"/rebase-apply ||
 154                        die "No rebase in progress?"
 155
 156                git diff-files --quiet --ignore-submodules || {
 157                        echo "You must edit all merge conflicts and then"
 158                        echo "mark them as resolved using git add"
 159                        exit 1
 160                }
 161                if test -d "$dotest"
 162                then
 163                        prev_head=$(cat "$dotest/prev_head")
 164                        end=$(cat "$dotest/end")
 165                        msgnum=$(cat "$dotest/msgnum")
 166                        onto=$(cat "$dotest/onto")
 167                        continue_merge
 168                        while test "$msgnum" -le "$end"
 169                        do
 170                                call_merge "$msgnum"
 171                                continue_merge
 172                        done
 173                        finish_rb_merge
 174                        exit
 175                fi
 176                head_name=$(cat "$GIT_DIR"/rebase-apply/head-name) &&
 177                onto=$(cat "$GIT_DIR"/rebase-apply/onto) &&
 178                orig_head=$(cat "$GIT_DIR"/rebase-apply/orig-head) &&
 179                git am --resolved --3way --resolvemsg="$RESOLVEMSG" &&
 180                move_to_original_branch
 181                exit
 182                ;;
 183        --skip)
 184                test -d "$dotest" -o -d "$GIT_DIR"/rebase-apply ||
 185                        die "No rebase in progress?"
 186
 187                git reset --hard HEAD || exit $?
 188                if test -d "$dotest"
 189                then
 190                        git rerere clear
 191                        prev_head=$(cat "$dotest/prev_head")
 192                        end=$(cat "$dotest/end")
 193                        msgnum=$(cat "$dotest/msgnum")
 194                        msgnum=$(($msgnum + 1))
 195                        onto=$(cat "$dotest/onto")
 196                        while test "$msgnum" -le "$end"
 197                        do
 198                                call_merge "$msgnum"
 199                                continue_merge
 200                        done
 201                        finish_rb_merge
 202                        exit
 203                fi
 204                head_name=$(cat "$GIT_DIR"/rebase-apply/head-name) &&
 205                onto=$(cat "$GIT_DIR"/rebase-apply/onto) &&
 206                orig_head=$(cat "$GIT_DIR"/rebase-apply/orig-head) &&
 207                git am -3 --skip --resolvemsg="$RESOLVEMSG" &&
 208                move_to_original_branch
 209                exit
 210                ;;
 211        --abort)
 212                test -d "$dotest" -o -d "$GIT_DIR"/rebase-apply ||
 213                        die "No rebase in progress?"
 214
 215                git rerere clear
 216                if test -d "$dotest"
 217                then
 218                        move_to_original_branch
 219                else
 220                        dotest="$GIT_DIR"/rebase-apply
 221                        move_to_original_branch
 222                fi
 223                git reset --hard $(cat "$dotest/orig-head")
 224                rm -r "$dotest"
 225                exit
 226                ;;
 227        --onto)
 228                test 2 -le "$#" || usage
 229                newbase="$2"
 230                shift
 231                ;;
 232        -M|-m|--m|--me|--mer|--merg|--merge)
 233                do_merge=t
 234                ;;
 235        -s=*|--s=*|--st=*|--str=*|--stra=*|--strat=*|--strate=*|\
 236                --strateg=*|--strategy=*|\
 237        -s|--s|--st|--str|--stra|--strat|--strate|--strateg|--strategy)
 238                case "$#,$1" in
 239                *,*=*)
 240                        strategy=`expr "z$1" : 'z-[^=]*=\(.*\)'` ;;
 241                1,*)
 242                        usage ;;
 243                *)
 244                        strategy="$2"
 245                        shift ;;
 246                esac
 247                do_merge=t
 248                ;;
 249        -v|--verbose)
 250                verbose=t
 251                ;;
 252        --whitespace=*)
 253                git_am_opt="$git_am_opt $1"
 254                ;;
 255        -C*)
 256                git_am_opt="$git_am_opt $1"
 257                ;;
 258        -*)
 259                usage
 260                ;;
 261        *)
 262                break
 263                ;;
 264        esac
 265        shift
 266done
 267
 268# Make sure we do not have $GIT_DIR/rebase-apply
 269if test -z "$do_merge"
 270then
 271        if mkdir "$GIT_DIR"/rebase-apply
 272        then
 273                rmdir "$GIT_DIR"/rebase-apply
 274        else
 275                echo >&2 '
 276It seems that I cannot create a '"$GIT_DIR"'/rebase-apply directory,
 277and I wonder if you are in the middle of patch application or another
 278rebase.  If that is not the case, please
 279        rm -fr '"$GIT_DIR"'/rebase-apply
 280 and run me again.  I am stopping in case you still have something
 281valuable there.'
 282                exit 1
 283        fi
 284else
 285        if test -d "$dotest"
 286        then
 287                die "previous rebase directory $dotest still exists." \
 288                        'try git-rebase < --continue | --abort >'
 289        fi
 290fi
 291
 292# The tree must be really really clean.
 293git update-index --ignore-submodules --refresh || exit
 294diff=$(git diff-index --cached --name-status -r --ignore-submodules HEAD --)
 295case "$diff" in
 296?*)     echo "cannot rebase: your index is not up-to-date"
 297        echo "$diff"
 298        exit 1
 299        ;;
 300esac
 301
 302# The upstream head must be given.  Make sure it is valid.
 303upstream_name="$1"
 304upstream=`git rev-parse --verify "${upstream_name}^0"` ||
 305    die "invalid upstream $upstream_name"
 306
 307# Make sure the branch to rebase onto is valid.
 308onto_name=${newbase-"$upstream_name"}
 309onto=$(git rev-parse --verify "${onto_name}^0") || exit
 310
 311# If a hook exists, give it a chance to interrupt
 312if test -x "$GIT_DIR/hooks/pre-rebase"
 313then
 314        "$GIT_DIR/hooks/pre-rebase" ${1+"$@"} || {
 315                echo >&2 "The pre-rebase hook refused to rebase."
 316                exit 1
 317        }
 318fi
 319
 320# If the branch to rebase is given, that is the branch we will rebase
 321# $branch_name -- branch being rebased, or HEAD (already detached)
 322# $orig_head -- commit object name of tip of the branch before rebasing
 323# $head_name -- refs/heads/<that-branch> or "detached HEAD"
 324switch_to=
 325case "$#" in
 3262)
 327        # Is it "rebase other $branchname" or "rebase other $commit"?
 328        branch_name="$2"
 329        switch_to="$2"
 330
 331        if git show-ref --verify --quiet -- "refs/heads/$2" &&
 332           branch=$(git rev-parse --verify "refs/heads/$2" 2>/dev/null)
 333        then
 334                head_name="refs/heads/$2"
 335        elif branch=$(git rev-parse --verify "$2" 2>/dev/null)
 336        then
 337                head_name="detached HEAD"
 338        else
 339                usage
 340        fi
 341        ;;
 342*)
 343        # Do not need to switch branches, we are already on it.
 344        if branch_name=`git symbolic-ref -q HEAD`
 345        then
 346                head_name=$branch_name
 347                branch_name=`expr "z$branch_name" : 'zrefs/heads/\(.*\)'`
 348        else
 349                head_name="detached HEAD"
 350                branch_name=HEAD ;# detached
 351        fi
 352        branch=$(git rev-parse --verify "${branch_name}^0") || exit
 353        ;;
 354esac
 355orig_head=$branch
 356
 357# Now we are rebasing commits $upstream..$branch on top of $onto
 358
 359# Check if we are already based on $onto with linear history,
 360# but this should be done only when upstream and onto are the same.
 361mb=$(git merge-base "$onto" "$branch")
 362if test "$upstream" = "$onto" && test "$mb" = "$onto" &&
 363        # linear history?
 364        ! (git rev-list --parents "$onto".."$branch" | grep " .* ") > /dev/null
 365then
 366        # Lazily switch to the target branch if needed...
 367        test -z "$switch_to" || git checkout "$switch_to"
 368        echo >&2 "Current branch $branch_name is up to date."
 369        exit 0
 370fi
 371
 372if test -n "$verbose"
 373then
 374        echo "Changes from $mb to $onto:"
 375        # We want color (if set), but no pager
 376        GIT_PAGER='' git diff --stat --summary "$mb" "$onto"
 377fi
 378
 379# Detach HEAD and reset the tree
 380echo "First, rewinding head to replay your work on top of it..."
 381git checkout -q "$onto^0" || die "could not detach HEAD"
 382git update-ref ORIG_HEAD $branch
 383
 384# If the $onto is a proper descendant of the tip of the branch, then
 385# we just fast forwarded.
 386if test "$mb" = "$branch"
 387then
 388        echo >&2 "Fast-forwarded $branch_name to $onto_name."
 389        move_to_original_branch
 390        exit 0
 391fi
 392
 393if test -z "$do_merge"
 394then
 395        git format-patch -k --stdout --full-index --ignore-if-in-upstream \
 396                "$upstream..$orig_head" |
 397        git am $git_am_opt --rebasing --resolvemsg="$RESOLVEMSG" &&
 398        move_to_original_branch
 399        ret=$?
 400        test 0 != $ret -a -d "$GIT_DIR"/rebase-apply &&
 401                echo $head_name > "$GIT_DIR"/rebase-apply/head-name &&
 402                echo $onto > "$GIT_DIR"/rebase-apply/onto &&
 403                echo $orig_head > "$GIT_DIR"/rebase-apply/orig-head
 404        exit $ret
 405fi
 406
 407# start doing a rebase with git-merge
 408# this is rename-aware if the recursive (default) strategy is used
 409
 410mkdir -p "$dotest"
 411echo "$onto" > "$dotest/onto"
 412echo "$onto_name" > "$dotest/onto_name"
 413prev_head=$orig_head
 414echo "$prev_head" > "$dotest/prev_head"
 415echo "$orig_head" > "$dotest/orig-head"
 416echo "$head_name" > "$dotest/head-name"
 417
 418msgnum=0
 419for cmt in `git rev-list --reverse --no-merges "$upstream..$orig_head"`
 420do
 421        msgnum=$(($msgnum + 1))
 422        echo "$cmt" > "$dotest/cmt.$msgnum"
 423done
 424
 425echo 1 >"$dotest/msgnum"
 426echo $msgnum >"$dotest/end"
 427
 428end=$msgnum
 429msgnum=1
 430
 431while test "$msgnum" -le "$end"
 432do
 433        call_merge "$msgnum"
 434        continue_merge
 435done
 436
 437finish_rb_merge